#!/bin/bash
#
# Copyright (c) 2008 SuSE Linux AG. Nuernberg, Germany.
#
BACKUPDIR=/var/adm/backup/imap
DBDIR=/var/lib/imap
BACKUPBASENAME=mailboxes.txt
NUM_BACKUPS_TO_KEEP=10
backup_name() {
    suffix=$(date +%Y-%m-%d)
    serial=00
    backupfile="$BACKUPDIR/$BACKUPBASENAME.$suffix.$serial.gz"
    while [ -f $backupfile ]; do
	serial=$(printf "%02d" $(expr $serial + 1))
	backupfile="$BACKUPDIR/$BACKUPBASENAME.$suffix.$serial.gz"
    done
    echo $backupfile
}

remove_old() {
    rm -f -- `ls -t -- $BACKUPDIR/$BACKUPBASENAME.*.gz | sed -e 1,${NUM_BACKUPS_TO_KEEP}d`
}
# ---------------------- MAIN -------------------

test -d $BACKUPDIR || mkdir -m 700 $BACKUPDIR
chown cyrus.mail $BACKUPDIR

bakfile=$(backup_name)
dumpfile=$DBDIR/$BACKUPBASENAME
rm -f $bakfile
rm -f $dumpfile
su -s /bin/sh - cyrus -c /usr/sbin/ctl_mboxlist > $dumpfile
gzip -9 -c < $dumpfile > $bakfile
chown cyrus.mail $dumpfile
chmod 640 $dumpfile
chown cyrus.mail $bakfile
chmod 640 $bakfile
remove_old
